#ifndef INCLUDE__Mainwindow_hxx_
#define INCLUDE__Mainwindow_hxx_

#include <memory>
#include <map>
#include <set>
#include <QTextEdit>
#include <QPushButton>
#include <QMainWindow>
#include <QListWidget>
#include <QStackedWidget>

#include "disassembler/Disassembler.hxx"
#include "widgets/BasicBlockWidget.hxx"
#include "widgets/ScriptingDock.hxx"
#include "core/InformationManager.hxx"

class Mainwindow : public QMainWindow {
	Q_OBJECT
public:
	Mainwindow(InformationManager* mgr);
private:
	void addFunction(Function* fun);

	QTextEdit *textEdit;
	QPushButton *quitButton;
	QMenu *fileMenu;

	QTabWidget * tabwidget;
	QListWidget * listWidget;
	QStackedWidget * stackedWidget;
	QDockWidget * dockWidget;
	ScriptingDock * scripting;

	QAction *exitAction;
	QAction *openAction;

	std::map<uint64_t, BasicBlockWidget*> blocks;
	std::set<Function*> functions;
	InformationManager* manager;
private Q_SLOTS:
	void quit();
	void open();
};

#endif /* INCLUDE__Mainwindow_hxx_ */
